"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.mapClass2Resolvers = exports.isSubscription = exports.isQuery = exports.isMutation = void 0;

var _regenerator = _interopRequireDefault(require("@babel/runtime/regenerator"));

var _lodash = require("lodash");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

function _objectSpread2(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; var ownKeys = Object.keys(source); if (typeof Object.getOwnPropertySymbols === 'function') { ownKeys = ownKeys.concat(Object.getOwnPropertySymbols(source).filter(function (sym) { return Object.getOwnPropertyDescriptor(source, sym).enumerable; })); } ownKeys.forEach(function (key) { _defineProperty(target, key, source[key]); }); } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance"); }

function _iterableToArrayLimit(arr, i) { var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }

var rootType = {
  Mutation: {},
  Query: {}
};

var __beforeGraphQLCall, __afterGraphQLCall;

var isMutation = function isMutation(target, name, descriptor) {
  //babel7适应性改造
  name = name || target.key;
  descriptor = descriptor || target.descriptor; //

  if (rootType.Mutation[name]) throw new Error("".concat(target.name, "\u7C7B\u4E2D\u7684").concat(name, "\u65B9\u6CD5\u540D\u79F0\u5DF2\u88AB\u5176\u4ED6\u7C7B\u65B9\u6CD5\u62A2\u6CE8\uFF0C\u5BFC\u81F4\u547D\u540D\u51B2\u7A81\uFF0C\u8BF7\u4FEE\u6539")); //

  if (!descriptor) throw new Error("isMutation\u4E0D\u652F\u6301\u4FEE\u9970\u7C7B(".concat(target, " ").concat(name, ")\uFF0C\u6216\u9519\u8BEF\u7528\u6CD5\uFF1A'@isMutation()'"));
  var oldValue = descriptor.value;
  descriptor.value =
  /*#__PURE__*/
  _asyncToGenerator(
  /*#__PURE__*/
  _regenerator["default"].mark(function _callee() {
    var _ref2,
        _ref3,
        _,
        params,
        ctx,
        ___,
        _ref4,
        request,
        modelSetting,
        result,
        _args = arguments;

    return _regenerator["default"].wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            console.log("===========>===========> invoke API: ".concat(target.name, ".").concat(name, "() in @isMutation ...."));
            _ref2 = _args || {}, _ref3 = _slicedToArray(_ref2, 4), _ = _ref3[0], params = _ref3[1], ctx = _ref3[2], ___ = _ref3[3];
            _ref4 = ctx || {}, request = _ref4.request;

            if (!(__beforeGraphQLCall && typeof __beforeGraphQLCall === 'function')) {
              _context.next = 8;
              break;
            }

            //如果有要对传入参数做验证，则在fn_beforeCall中处理
            modelSetting = target.__modelSetting ? target.__modelSetting() : {}; //返回最新的ctx

            _context.next = 7;
            return __beforeGraphQLCall({
              apipath: name,
              req: request,
              params: params,
              ctx: ctx,
              modelSetting: modelSetting
            });

          case 7:
            ctx = _context.sent;

          case 8:
            _context.next = 10;
            return oldValue.apply(void 0, Array.prototype.slice.call(_args).concat([ctx]));

          case 10:
            result = _context.sent;

            if (!(__afterGraphQLCall && typeof __afterGraphQLCall === 'function')) {
              _context.next = 15;
              break;
            }

            _context.next = 14;
            return __afterGraphQLCall({
              apipath: name,
              req: request,
              result: result,
              ctx: ctx
            });

          case 14:
            result = _context.sent;

          case 15:
            return _context.abrupt("return", result);

          case 16:
          case "end":
            return _context.stop();
        }
      }
    }, _callee);
  })); //

  rootType.Mutation[name] = descriptor.value;
  return descriptor;
};

exports.isMutation = isMutation;

var isQuery = function isQuery(target, name, descriptor) {
  //babel7适应性改造
  name = name || target.key;
  descriptor = descriptor || target.descriptor;
  if (rootType.Query[name]) throw new Error("".concat(target.name, "\u7C7B\u4E2D\u7684").concat(name, "\u65B9\u6CD5\u540D\u79F0\u5DF2\u88AB\u5176\u4ED6\u7C7B\u65B9\u6CD5\u62A2\u6CE8\uFF0C\u5BFC\u81F4\u547D\u540D\u51B2\u7A81\uFF0C\u8BF7\u4FEE\u6539")); //

  if (!descriptor) throw new Error('isQuery不支持修饰类');
  var oldValue = descriptor.value;
  descriptor.value =
  /*#__PURE__*/
  _asyncToGenerator(
  /*#__PURE__*/
  _regenerator["default"].mark(function _callee2() {
    var _ref6,
        _ref7,
        _,
        params,
        ctx,
        ___,
        _ref8,
        request,
        modelSetting,
        result,
        _args2 = arguments;

    return _regenerator["default"].wrap(function _callee2$(_context2) {
      while (1) {
        switch (_context2.prev = _context2.next) {
          case 0:
            console.log("===========>===========> invoke API: ".concat(target.name, ".").concat(name, "() in @isQuery ...."));
            _ref6 = _args2 || {}, _ref7 = _slicedToArray(_ref6, 4), _ = _ref7[0], params = _ref7[1], ctx = _ref7[2], ___ = _ref7[3];
            _ref8 = ctx || {}, request = _ref8.request;

            if (process.env.NODE_ENV !== "production") {
              console.log("__beforeGraphQLCall:" + _typeof(__beforeGraphQLCall));
            }

            if (!(__beforeGraphQLCall && typeof __beforeGraphQLCall === 'function')) {
              _context2.next = 9;
              break;
            }

            //如果有要对传入参数做验证，则在fn_beforeCall中处理
            modelSetting = target.__modelSetting ? target.__modelSetting() : {}; //返回最新的ctx

            _context2.next = 8;
            return __beforeGraphQLCall({
              apipath: name,
              req: request,
              params: params,
              ctx: ctx,
              modelSetting: modelSetting
            });

          case 8:
            ctx = _context2.sent;

          case 9:
            _context2.next = 11;
            return oldValue.apply(void 0, Array.prototype.slice.call(_args2).concat([ctx]));

          case 11:
            result = _context2.sent;

            //
            if (process.env.NODE_ENV !== "production") {
              console.log("__beforeGraphQLCall:" + _typeof(__afterGraphQLCall));
            } //执行后的拦截


            if (!(__afterGraphQLCall && typeof __afterGraphQLCall === 'function')) {
              _context2.next = 17;
              break;
            }

            _context2.next = 16;
            return __afterGraphQLCall({
              apipath: name,
              req: request,
              result: result,
              params: params,
              ctx: ctx
            });

          case 16:
            result = _context2.sent;

          case 17:
            return _context2.abrupt("return", result);

          case 18:
          case "end":
            return _context2.stop();
        }
      }
    }, _callee2);
  })); //

  rootType.Query[name] = descriptor.value;
  return descriptor;
};

exports.isQuery = isQuery;

var isSubscription = function isSubscription(target, name, descriptor) {
  throw new Error('isSubscription的修饰器尚未实现');
};

exports.isSubscription = isSubscription;

var mapClass2Resolvers = function mapClass2Resolvers(_ref9) {
  var _ref9$modelClasses = _ref9.modelClasses,
      modelClasses = _ref9$modelClasses === void 0 ? [] : _ref9$modelClasses,
      beforeGraphQLCall = _ref9.beforeGraphQLCall,
      afterGraphQLCall = _ref9.afterGraphQLCall,
      _ref9$otherRootType = _ref9.otherRootType,
      otherRootType = _ref9$otherRootType === void 0 ? {} : _ref9$otherRootType;
  //检查是否所有的静态业务API方法，都标记了GraphQL操作类型
  var methods = (0, _lodash.keys)(_objectSpread2({}, rootType.Mutation, {}, rootType.Query));
  var noDecorators = 0;
  modelClasses.forEach(function (classA) {
    Object.getOwnPropertyNames(classA).forEach(function (prop) {
      //排除类的基本属性
      if ((0, _lodash.indexOf)(['name', 'length', 'prototype', '__modelSetting'], prop) === -1) {
        if ((0, _lodash.indexOf)(methods, prop) === -1) {
          console.error(" !.....\u53D1\u73B0\u672A\u4FEE\u9970\u64CD\u4F5C\u7C7B\u578B\u6807\u8BB0\u7684\u4E1A\u52A1\u65B9\u6CD5\uFF1A  ".concat(classA.name + "." + prop));
          noDecorators++;
        }
      }
    });
  });
  if (noDecorators > 0) throw new Error('在API业务类中 发现有未标记GraphQL操作类型的业务方法，请检查！ 如属于内部业务方法而无需暴露到接口的，请转移到private文件夹内！或定义到业务业务类外部！');
  if (__beforeGraphQLCall) throw new Error('__beforeGraphQLCall已被初始化，每个进程全局只能构建一次mapClass2Resolvers映射');
  __beforeGraphQLCall = beforeGraphQLCall;
  if (__afterGraphQLCall) throw new Error('__afterGraphQLCall已被初始化，每个进程全局只能构建一次mapClass2Resolvers映射');
  __afterGraphQLCall = afterGraphQLCall; //从otherRootType中萃取出可能已存在的Query和Mutation，被覆盖

  var _otherRootType$Query = otherRootType.Query,
      Query = _otherRootType$Query === void 0 ? {} : _otherRootType$Query,
      _otherRootType$Mutati = otherRootType.Mutation,
      Mutation = _otherRootType$Mutati === void 0 ? {} : _otherRootType$Mutati,
      otherRoot = _objectWithoutProperties(otherRootType, ["Query", "Mutation"]);

  return _objectSpread2({}, otherRoot, {
    Query: _objectSpread2({}, Query, {}, rootType.Query),
    Mutation: _objectSpread2({}, Mutation, {}, rootType.Mutation)
  });
};

exports.mapClass2Resolvers = mapClass2Resolvers;