"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _path = _interopRequireDefault(require("path"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _objectSpread2(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; var ownKeys = Object.keys(source); if (typeof Object.getOwnPropertySymbols === 'function') { ownKeys = ownKeys.concat(Object.getOwnPropertySymbols(source).filter(function (sym) { return Object.getOwnPropertyDescriptor(source, sym).enumerable; })); } ownKeys.forEach(function (key) { _defineProperty(target, key, source[key]); }); } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

/*
 获取package中的系统名
 */
var load_package_name = function load_package_name() {
  var _require = require(_path["default"].join(process.cwd(), 'package.json')),
      _require$name = _require.name,
      name = _require$name === void 0 ? '' : _require$name;

  var applicationName = name.split(".")[0];
  console.log("\u540E\u53F0\u6743\u9650\u7BA1\u7406\u6A21\u5757\u4ECEpackage.json\u4E2D\u83B7\u53D6\u5F53\u524D\u4E1A\u52A1\u7CFB\u7EDF\u540D\uFF08\u53D6name.split(\".\")[0]\uFF09\uFF1A".concat(applicationName));
  if (!applicationName) throw new Error("\u4E1A\u52A1\u7CFB\u7EDF\u540D\u83B7\u53D6\u5931\u8D25\uFF0C\u6743\u9650\u7BA1\u7406\u8BA4\u8BC1\u5C06\u5931\u6548\uFF0C\u8BF7\u786E\u8BA4\u5B58\u5728package.json\u4E14\u5176\u4E2D\u5DF2\u914D\u7F6Ename\u5C5E\u6027");
  return applicationName;
};

var env = process.env.PRODUCTION_TYPE || process.env.NODE_ENV;
var prot = (typeof window === "undefined" ? "undefined" : _typeof(window)) === 'object' ? 'https:' : 'http:';
var urlpath = "//rulecenter".concat(env === 'production' ? "" : "-test:", ".api.gankao.com");
var validUrl = "".concat(prot).concat(urlpath);
var class2api_config = {
  /**
   * 系统名称,默认读取package.json中的name
   */
  name: load_package_name(),

  /**
   * 权限认证中心
   */
  admin_rule_center: {
    /**
        * 用户身份验证接口
        */
    auth: validUrl + "/gkauth/authAdminAccount",

    /**
     * 权限验证接口
     */
    validator: validUrl + "/gkrulemanager/validate",

    /**
     * 权限配置表的注册接口
     */
    register: validUrl + "/gkrulemanager/updateCertList"
  }
};

try {
  var _require2 = require(_path["default"].join(process.cwd(), 'class2api.config.js')),
      customConfig = _require2.config;

  class2api_config = _objectSpread2({}, class2api_config, {}, customConfig);
  console.log("\u540E\u53F0\u6743\u9650\u7BA1\u7406\u6A21\u5757\uFF1A\u53D1\u73B0class2api.config.js\u914D\u7F6E\uFF0C\u542F\u7528\u81EA\u5B9A\u4E49\u7684\u6743\u9650\u8BA4\u8BC1\u914D\u7F6E(".concat(env, ")\uFF1A").concat(JSON.stringify(class2api_config)));
} catch (err) {
  console.log("\u540E\u53F0\u6743\u9650\u7BA1\u7406\u6A21\u5757\uFF1A\u672A\u627E\u5230class2api.config.js\u914D\u7F6E\uFF0C\u542F\u7528\u5185\u7F6E\u7684\u6743\u9650\u8BA4\u8BC1\u914D\u7F6E(".concat(env, ")\uFF1A").concat(JSON.stringify(class2api_config)));
}

var _default = function _default() {
  return _objectSpread2({}, class2api_config);
};

exports["default"] = _default;