"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.save2Doc = exports.WebInvokeHepler = exports.ApiDesc = exports.setApiRoot = void 0;

var _regenerator = _interopRequireDefault(require("@babel/runtime/regenerator"));

var _request = _interopRequireDefault(require("request"));

var _bluebird = _interopRequireDefault(require("bluebird"));

var _fs = _interopRequireDefault(require("fs"));

var _lodash = require("lodash");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance"); }

function _iterableToArrayLimit(arr, i) { var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

function _objectSpread2(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; var ownKeys = Object.keys(source); if (typeof Object.getOwnPropertySymbols === 'function') { ownKeys = ownKeys.concat(Object.getOwnPropertySymbols(source).filter(function (sym) { return Object.getOwnPropertyDescriptor(source, sym).enumerable; })); } ownKeys.forEach(function (key) { _defineProperty(target, key, source[key]); }); } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }

_bluebird["default"].promisifyAll(_request["default"]);

JSON.stringifyline = function (Obj) {
  return JSON.stringify(Obj, null, 2);
};

var remote_api;
var docapi = [];

var joinParamsForGet = function joinParamsForGet(props) {
  var ret = [];
  (0, _lodash.map)((0, _lodash.keys)(props), function (k) {
    ret.push("".concat(k, "=").concat(props[k]));
  });
  return ret.join("&");
};

var setApiRoot = function setApiRoot(apiRoot) {
  remote_api = apiRoot;
};

exports.setApiRoot = setApiRoot;

var ApiDesc = function ApiDesc(desc) {
  return desc;
};

exports.ApiDesc = ApiDesc;

var WebInvokeHepler = function WebInvokeHepler(user, method) {
  if (!user) throw new Error("WebInvokeHepler\u65B9\u6CD5\u7F3A\u5C11\u53C2\u6570user");
  if (!method) method = 'post';
  var _user$token = user.token,
      token = _user$token === void 0 ? '' : _user$token,
      _user$jwtoken = user.jwtoken,
      jwtoken = _user$jwtoken === void 0 ? '' : _user$jwtoken,
      _user$otherheaders = user.otherheaders,
      otherheaders = _user$otherheaders === void 0 ? {} : _user$otherheaders;
  return (
    /*#__PURE__*/
    function () {
      var _ref = _asyncToGenerator(
      /*#__PURE__*/
      _regenerator["default"].mark(function _callee(apiPath, postParams, apiDesc) {
        var options, funPromise, _ref2, body;

        return _regenerator["default"].wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                options = {
                  url: remote_api + apiPath,
                  rejectUnauthorized: false,
                  headers: _objectSpread2({}, otherheaders, {
                    token: token,
                    jwtoken: jwtoken // 这里提供身份验证的token，注意命名为：jwtoken

                  }),
                  body: postParams,
                  json: true
                };
                funPromise = method === 'post' ? _request["default"].postAsync(options) : _request["default"].getAsync(options.url + "?" + joinParamsForGet(_objectSpread2({}, postParams, {}, options.headers)));
                _context.next = 4;
                return funPromise;

              case 4:
                _ref2 = _context.sent;
                body = _ref2.body;

                if (apiDesc) {
                  docapi.push([apiDesc, options.uri, postParams, body]);
                }

                if (method !== 'post') {
                  try {
                    body = JSON.parse(body);
                  } catch (err) {
                    console.error("error in class2api ...JSON.parse(body) :");
                    console.error(err);
                  }
                }

                return _context.abrupt("return", body);

              case 9:
              case "end":
                return _context.stop();
            }
          }
        }, _callee);
      }));

      return function (_x, _x2, _x3) {
        return _ref.apply(this, arguments);
      };
    }()
  );
};

exports.WebInvokeHepler = WebInvokeHepler;

var save2Doc = function save2Doc(_ref3) {
  var _ref3$save2File = _ref3.save2File,
      save2File = _ref3$save2File === void 0 ? "api.MD" : _ref3$save2File;
  console.log("\u751F\u6210API\u63A5\u53E3\u8BF7\u6C42\u7684\u5FEB\u7167 ... ...");
  var str = [];
  docapi.forEach(function (item) {
    var lines = [];

    var _item = _slicedToArray(item, 4),
        apiDesc = _item[0],
        uri = _item[1],
        postParams = _item[2],
        body = _item[3];

    lines.push("# ".concat(apiDesc, " #"));
    lines.push("- \u63A5\u53E3\uFF1A".concat(uri));
    lines.push("- post\u53C2\u6570\uFF1A");
    lines.push('```json');
    lines.push(JSON.stringifyline(postParams));
    lines.push('```');
    lines.push("- \u8BF7\u6C42\u7ED3\u679C\uFF1A");
    lines.push('```json');
    lines.push(JSON.stringifyline(body));
    lines.push('```');
    str.push(lines.join("\r"));
  });

  _fs["default"].writeFileSync(save2File, str.join("\n\r"));

  console.log("API\u63A5\u53E3\u8BF7\u6C42\u7684\u5FEB\u7167 \u751F\u6210\u6210\u529F\uFF01");
};

exports.save2Doc = save2Doc;